config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  devise_for :users
  root to: "rooms#index"

  resources :rooms
  resources :room_bookings, only: [:create, :destroy]
end

app/models/application_record.rb
# frozen_string_literal: true
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/room.rb
# frozen_string_literal: true
class Room < ApplicationRecord
  validates :name, presence: true
  has_many :room_bookings, dependent: :destroy

  SCHEDULES = [
                            "06:00", "07:00", "08:00", "09:00", "10:00", "11:00", "12:00",
                            "13:00", "14:00", "15:00", "16:00", "17:00", "18:00", "19:00",
                            "20:00", "21:00", "22:00", "23:00"
                          ].freeze
end

app/models/room_booking.rb
# frozen_string_literal: true
class RoomBooking < ApplicationRecord
  validates :hour, presence: true
  validates :date, presence: true

  belongs_to :user
  belongs_to :room
end

app/models/user.rb
# frozen_string_literal: true
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :room_bookings, dependent: :destroy
end

app/controllers/application_controller.rb
# frozen_string_literal: true
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/room_bookings_controller.rb
# frozen_string_literal: true
class RoomBookingsController < ApplicationController
  before_action :authenticate_user!

  def create
    RoomBooking.create!(room_id: params[:room], user: current_user, date: params[:date], hour: params[:hour])
    head :ok
  end

  def destroy
    @room_booking = RoomBooking.find(params[:id])
    if @room_booking.user == current_user
      @room_booking.destroy
    end
    head :ok
  end
end

app/controllers/rooms_controller.rb
# frozen_string_literal: true
class RoomsController < ApplicationController
  before_action :authenticate_user!

  def index
    @rooms = Room.all
  end

  def new
    @room = Room.new
  end

  def create
    @room = Room.new(room_params)

    if @room.save
      redirect_to rooms_path, notice: 'Sala criada com sucesso'
    else
      render :new
    end
  end

  def edit
    @room = Room.find(params[:id])
  end

  def update
    @room = Room.find(params[:id])

    if @room.update(room_params)
      redirect_to rooms_path, notice: 'Sala atualizada com sucesso'
    else
      render :edit
    end
  end

  def show
    @room = Room.find(params[:id])
    @weekdays = ((Date.current.at_beginning_of_week)..(Date.current.at_end_of_week - 2.days)).to_a
    @room_bookings = RoomBooking.where(date: @weekdays)
  end

  def destroy
    @room = Room.find(params[:id])
    if @room.destroy
      redirect_to rooms_path, notice: 'Sala deletada com sucesso'
    else
      redirect_to rooms_path, notice: 'Não foi possivel deletar sala, tente mais tarde'
    end
  end

  private
  def room_params
    params.require(:room).permit(:name)
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true
module ApplicationHelper
end

app/views/layouts/application.html.slim
doctype html
html
  head
    title
      | MeetingRoom
    = csrf_meta_tags

    = stylesheet_link_tag    'application', media: 'all'
    = javascript_include_tag 'application'

  body
    header
      nav.navbar.navbar-default
        .container-fluid
          .collapse.navbar-collapse#navbar-collapse
            a.navbar-brand
              | Reserva de Salas
            - if current_user
              ul.nav.navbar-nav
                li
                  = link_to "Listar Salas", rooms_path
                li
                  = link_to "Incluir Sala", new_room_path
              ul.nav.navbar-nav.navbar-right
                p.navbar-text
                  = current_user.email
                li
                  = link_to "Sair", destroy_user_session_path, method: :delete
  .container
    = yield

app/views/rooms/_form.html.slim
= simple_form_for @room do |f|
  = f.error_notification
  = f.input :name
  = f.submit class: 'btn btn-primary'
  | &nbsp; &nbsp;
  = link_to 'Cancelar', rooms_path, class: 'btn btn-default'

app/views/rooms/edit.html.slim
.page-header
  h1
    | Editar Sala
= render "form"

app/views/rooms/index.html.slim
.page-header
  h1
    | Salas
.row
  .col-sm-12
    table.table.table-striped
      thead
        tr
          th
            | Id
          th
            | Nome
          th
            | Ações
      tbody
        - @rooms.each do |room|
          tr
            td
              = room.id
            td
              = room.name
            td
              = link_to 'Editar', edit_room_path(room)
              | &nbsp; &nbsp;
              = link_to 'Show', room_path(room)
              | &nbsp; &nbsp;
              = link_to 'Deletar', room_path(room), method: :delete, class: "cpy-delete-room-#{room.id}", data: {confirm: 'Tem certeza que deseja deletar esta sala?'}

app/views/rooms/new.html.slim
.page-header
  h1
    | Incluir Sala
= render "form"

app/views/rooms/show.html.slim
.page-header
  h1
    | Visualizar sala
.row
  .col-sm-12
    h3
      = @room.name
.row
  .col-sm-12
    table.table.table-striped
      thead
        tr
          td
            | Horário
          td
            | Segunda
          td
            | Terça
          td
            | Quarta
          td
            | Quinta
          td
            | Sexta
        tbody#js-chedules
          - Room::SCHEDULES.each do | schedule|
            tr
              td
                = schedule
              - @weekdays.each do |weekday|
                - room_booking = @room_bookings.where(date: weekday, hour: schedule, room: @room)
                - if room_booking.empty?
                  td
                    a href="#" data-user="#{ current_user.email }" data-room-id="#{ @room.id }" data-date="#{ weekday }" data-hour="#{ schedule }" data-reserve-room=0 class="cpy-reserve-room"
                      | Disponível
                - else
                  td
                    p
                      | Reservado para &nbsp;
                      = current_user.email
                      - if room_booking.first.user == current_user
                        br
                        a href="#" data-cancel-room-booking=0 data-room-booking="#{ room_booking.first.id }" data-user="#{ current_user.email }" data-room-id="#{ @room.id }" data-date="#{ weekday }" data-hour="#{ schedule }"
                          | Cancelar

es6:
  import RoomBooking from "components/room_booking";
  $(document).ready(() => {
    new RoomBooking("#js-chedules");
  });